package ${basePackage}.frame.excel.handler;

import com.alibaba.excel.write.handler.RowWriteHandler;
import com.alibaba.excel.write.metadata.holder.WriteSheetHolder;
import com.alibaba.excel.write.metadata.holder.WriteTableHolder;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;

import java.util.Map;


public class WRowWriteHandler implements RowWriteHandler {
    private int errColIndex;
    private Map<Integer, String> errMap;

    public WRowWriteHandler(int errColIndex, Map<Integer, String> errMap) {
        this.errColIndex = errColIndex;
        this.errMap = errMap;
    }

    @Override
    public void beforeRowCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Integer integer, Integer integer1, Boolean isHead) {

    }

    @Override
    public void afterRowCreate(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Row row, Integer integer, Boolean isHead) {

    }

    @Override
    public void afterRowDispose(WriteSheetHolder writeSheetHolder, WriteTableHolder writeTableHolder, Row row, Integer rowIndex, Boolean isHead) {
        if (!isHead && !"".equals(errMap.getOrDefault(rowIndex, ""))) {
            Cell cell = row.createCell(errColIndex);
            cell.getCellStyle().setWrapText(true);
            cell.setCellValue(errMap.get(rowIndex));
        }
    }
}
