package ${basePackage}.frame.excel.listener;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import ${basePackage}.frame.excel.WHead;
import ${basePackage}.frame.excel.exception.TemplateNotMatchException;

import java.util.List;
import java.util.Map;


public class CheckHeadReadListener extends AnalysisEventListener {
    private List<WHead> wHeads;
    private TemplateNotMatchException[] es;

    public CheckHeadReadListener(List<WHead> wHeads, TemplateNotMatchException[] es) {
        this.wHeads = wHeads;
        this.es = es;
    }

    @Override
    public void invokeHeadMap(Map headMap, AnalysisContext context) {
        if (wHeads.size() != headMap.size()) {
            es[0] = new TemplateNotMatchException("文件列数量与模板不一致!");
            return;
        }
        es[0] = null;
        for (int i = 0; i < wHeads.size(); i++) {
            WHead wCol = wHeads.get(i);
            String cellValue = headMap.get(i).toString();
            if (!wCol.getName().equals(cellValue)) {
                es[0] = new TemplateNotMatchException(String.format("第 %d 列应为[ %s ]", i + 1, wCol.getName()));
                break;
            }
        }
    }

    @Override
    public void invoke(Object o, AnalysisContext analysisContext) {

    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {

    }

    @Override
    public boolean hasNext(AnalysisContext context) {
        return es[0] != null;
    }
}
